var pg = require("./driverpg");
var mysql = require("./drivermysql");

//Format : postgresql:<HOST>:<PORT>/database?user=<USER>&password=<PASSWORD>
//see http://www.petefreitag.com/articles/jdbc_urls/
var DatabaseTemplateCreator = function(uri) {
    this.uri = uri;
    this._parseUri(uri);
};

DatabaseTemplateCreator.prototype = {
    _parseUri: function(uri) {
        var index = uri.indexOf(":");
        if (index!=-1) {
            this.databaseKind = uri.substr(0, index);
            uri = uri.substring(index+1);
            index = uri.indexOf("/");
            this.configuration = {};
            this.parameters = {};
            if (index!=-1) {
                var hostPort = uri.substr(0, index);
                //console.log("hostPort = "+hostPort);
                var indexHostPort = hostPort.indexOf(":");
                if (indexHostPort!=-1) {
                    //console.log("1");
                    this.configuration["host"] = hostPort.substr(0, indexHostPort);
                    //console.log("host = "+this.configuration["host"]);
                    this.configuration["port"] = hostPort.substring(indexHostPort+1);
                    //console.log("port = "+this.configuration["port"]);
                } else if (hostPort!="") {
                    this.configuration["host"] = hostPort;
                }
                uri = uri.substring(index+1);
                index = uri.indexOf("?");
                if (index!=-1) {
                    this.configuration["database"] = uri.substr(0, index);
                    //console.log("database = "+this.configuration["database"]);
                    uri = uri.substring(index+1);
                    index = uri.indexOf("&");
                    while (index!=-1) {
                        var parameter = uri.substr(0, index);
                        var indexParameter = parameter.indexOf("=");
                        if (indexParameter!=-1) {
                            this.parameters[parameter.substr(0, indexParameter)] = parameter.substring(indexParameter+1);
                        }
                        uri = uri.substring(index+1);
                        index = uri.indexOf("&");
                    }
                    var parameter = uri;
                    var indexParameter = parameter.indexOf("=");
                    if (indexParameter!=-1) {
                        this.parameters[parameter.substr(0, indexParameter)] = parameter.substring(indexParameter+1);
                    }

                    /*for (var elt in this.parameters) {
                        console.log("parameter "+elt+" : "+this.parameters[elt]);
                    }*/

                    if (this.parameters["user"]!=null) {
                        this.configuration["user"] = this.parameters["user"];
                    }
                    if (this.parameters["password"]!=null) {
                        this.configuration["password"] = this.parameters["password"];
                    }
                } else {
                    this.configuration["database"] = uri;
                }
            } else {
                throw new Error("Unable to determine the host / port.");
            }
        } else {
            throw new Error("Unable to determine the database kind.");
        }
    },
    getDatabaseTemplate: function(callbacks) {
        var driver = null;
        if (this.databaseKind=="postgresql") {
            driver = pg;
        } else if (this.databaseKind=="mysql") {
            driver = mysql;
        }

        if (driver!=null) {
            return new driver.DatabaseTemplate(this.configuration, callbacks);
        } else {
            throw new Error("Database "+this.databaseKind+" isn't supported.");
        }
    },
    getTransactionTemplate: function() {
    },
    getUri: function() {
        return this.uri;
    },
    getDatabaseKind: function() {
        return this.databaseKind;
    },
    getConfiguration: function() {
        return this.configuration;
    }
};

/*var TransactionTemplate = function(client) {
    this.client = client;
};

TransactionTemplate.prototype = {
    doInTransaction: function(callback) {
        //begin
        try {
            callback(client);
            //commit
        } catch(err) {
            //rollback
        }
        //end
    }
};*/

module.exports = {
    DatabaseTemplateCreator: DatabaseTemplateCreator
};
