var sys = require("sys");
var generic = require("../lib/generic");

var Test = function(uri) {
    this.uri = uri;
}

Test.prototype = {
    execute: function(setUpCallback, testCallback, tearDownCallback) {
        var testExecuted = false;
        var tearDownExecuted = false;
        var creator = new generic.DatabaseTemplateCreator(this.uri);
        var databaseTemplate = creator.getDatabaseTemplate({
            onComplete: function(client) {
                if (testExecuted && !tearDownExecuted) {
                    tearDownExecuted = true;
                    databaseTemplate.doOnData(function(client) {
                        tearDownCallback(client);
                    });
                } else if (!testExecuted && !tearDownExecuted) {
                    testExecuted = true;
                    databaseTemplate.doOnData(function(client) {
                        testCallback(client);
                    });
                }
            }
        });
        databaseTemplate.doOnData(function(client) {
            setUpCallback(client);
        });
    }
}

module.exports = {
    Test: Test
};
