var driver = require("../lib/driver");

function test(uri, setUpCallback, testCallback, tearDownCallback) {
    var testExecuted = false;
    var tearDownExecuted = false;
    var creator = new driver.DatabaseTemplateCreator(uri);
    var databaseTemplate = creator.getDatabaseTemplate({
        onComplete: function(client) {
            if (testExecuted && !tearDownExecuted) {
                databaseTemplate.doOnData(function(client) {
                    tearDownCallback(client);
                });
            } else if (!testExecuted) {
                testExecuted = true;
                testCallback(client);
            }
        }
    });
    databaseTemplate.doOnData(function(client) {
        setUpCallback(client);
    });
}
