var sys = require("sys");
var assert = require("assert");
var driver = require("../lib/generic");

var postgresqlUri = "postgresql:localhost:5432/test?user=username&password=mypassword";
var creator1 = new driver.DatabaseTemplateCreator(postgresqlUri);

assert.equal(creator1.getUri(), postgresqlUri);
assert.equal(creator1.getDatabaseKind(), "postgresql");
var configuration1 = creator1.getConfiguration();
assert.equal("localhost", configuration1.host);
assert.equal("5432", configuration1.port);
assert.equal("test", configuration1.database);
assert.equal("username", configuration1.user);
assert.equal("mypassword", configuration1.password);

var template1 = creator1.getDatabaseTemplate();

var mysqlUri1 = "mysql:localhost:3306/test?user=username&password=mypassword";
var creator2 = new driver.DatabaseTemplateCreator(mysqlUri1);

assert.equal(creator2.getUri(), mysqlUri1);
assert.equal(creator2.getDatabaseKind(), "mysql");
var configuration2 = creator2.getConfiguration();
assert.equal("localhost", configuration2.host);
assert.equal("3306", configuration2.port);
assert.equal("test", configuration2.database);
assert.equal("username", configuration2.user);
assert.equal("mypassword", configuration2.password);

var template2 = creator2.getDatabaseTemplate();

var mysqlUri2 = "mysql:/test?user=username&password=mypassword";
var creator3 = new driver.DatabaseTemplateCreator(mysqlUri2);

assert.equal(creator3.getUri(), mysqlUri2);
assert.equal(creator3.getDatabaseKind(), "mysql");
var configuration3 = creator3.getConfiguration();
assert.ok(configuration3.host==null);
assert.ok(configuration3.port==null);
assert.equal("test", configuration3.database);
assert.equal("username", configuration3.user);
assert.equal("mypassword", configuration3.password);

var template2 = creator2.getDatabaseTemplate();
