var sys = require("sys");
var assert = require("assert");
var test = require("../lib/testframework");
console.log(sys.inspect(test));

var uri = "postgresql:localhost:5432/nodejs?user=templth&password=testtest";
var test = new test.Test(uri);

var setupExecuted = false;
var testExecuted = false;
var tearDownExecuted = false;

test.execute(function(client) {
   console.log("> setup");
   client.executeUpdate("insert into beatles (name,height) values($1,$2)", ['Ringo',152]);
   setupExecuted = true;
   assert.equal(setupExecuted, true);
   assert.equal(testExecuted, false);
   assert.equal(tearDownExecuted, false);
}, function(client) {
   console.log("> test");
   client.executeQuery("select * from beatles", function(result) {
        console.log("in callback - "+sys.inspect(result));
        assert.equal(1, result.length);
        assert.equal("Ringo", result[0].name);
        assert.equal(152, result[0].height);
        for (var cpt=0;cpt<result.length;cpt++) {
            console.log("- "+result[cpt].name);
        }
   });
   client.getTableMetadatas(function(result) {
       console.log("in callback - "+sys.inspect(result));
   });
   testExecuted = true;
   assert.equal(setupExecuted, true);
   assert.equal(testExecuted, true);
   assert.equal(tearDownExecuted, false);
}, function(client) {
   console.log("> teardown");
   client.executeUpdate("delete from beatles");
   tearDownExecuted = true;
   assert.equal(setupExecuted, true);
   assert.equal(testExecuted, true);
   assert.equal(tearDownExecuted, true);
});
